Index: branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/CRS/crsdom.F90
===================================================================
--- branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/CRS/crsdom.F90	(revision 6101)
+++ branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/CRS/crsdom.F90	(revision 6772)
@@ -579,251 +447,96 @@
             
                CASE( 'T', 'W' )
-                  !IF( cd_type == 'T' ) THEN
-                     DO jk = 1, jpk
-                        zsurf   (:,:,jk) =  p_e12(:,:) * p_e3(:,:,jk) *  p_mask(:,:,jk) 
-                        zsurfmsk(:,:,jk) =  zsurf(:,:,jk) 
-                    ENDDO
-                  !ELSE
-                  !  !cbr ????????????????????????????????
-                  !   zsurf   (:,:,1) =  p_e12(:,:) * p_e3(:,:,1)
-                  !   zsurfmsk(:,:,1) =  zsurf(:,:,1) *  p_mask(:,:,1) 
-                  !   DO jk = 2, jpk
-                  !      zsurf   (:,:,jk) =  p_e12(:,:) * p_e3(:,:,jk)
-                  !      zsurfmsk(:,:,jk) =  zsurf(:,:,jk) * p_mask(:,:,jk-1) 
-                  !   ENDDO
-                  !ENDIF
-         
-                  IF( nldj_crs == 1 .AND. ( ( mje_crs(2) - mjs_crs(2) ) < 2 ) ) THEN     !!cc bande du sud style ORCA2
-                     IF( mje_crs(2) - mjs_crs(2) == 1 ) THEN
-                        je_2 = mje_crs(2)
-                        DO jk = 1, jpk           
-                           DO ji = nistr, niend, nn_factx
-                              ii   = ( ji - mis_crs(2) ) * rfactx_r + 2       
-                              zflcrs =  p_fld(ji  ,je_2,jk) * zsurfmsk(ji  ,je_2,jk)   &
-                                &     + p_fld(ji+1,je_2,jk) * zsurfmsk(ji+1,je_2,jk)   &
-                                &     + p_fld(ji+2,je_2,jk) * zsurfmsk(ji+2,je_2,jk) 
- 
-                              zsfcrs =  zsurf(ji,je_2,jk) + zsurf(ji+1,je_2,jk) + zsurf(ji+2,je_2,jk) 
-                              !
-                              p_fld_crs(ii,2,jk) = zflcrs
-                              IF( zsfcrs /= 0.0 )  p_fld_crs(ii,2,jk) = zflcrs / zsfcrs
-                           ENDDO
-                        ENDDO
-                     ENDIF
-                  ELSE
-                     je_2 = mjs_crs(2)
-                     DO jk = 1, jpk           
-                        DO ji = nistr, niend, nn_factx
-                           ii   = ( ji - mis_crs(2) ) * rfactx_r + 2   
-                           zflcrs =  p_fld(ji  ,je_2  ,jk) * zsurfmsk(ji  ,je_2  ,jk) &
-                             &     + p_fld(ji+1,je_2  ,jk) * zsurfmsk(ji+1,je_2  ,jk) &
-                             &     + p_fld(ji+2,je_2  ,jk) * zsurfmsk(ji+2,je_2  ,jk) &
-                             &     + p_fld(ji  ,je_2+1,jk) * zsurfmsk(ji  ,je_2+1,jk) &
-                             &     + p_fld(ji+1,je_2+1,jk) * zsurfmsk(ji+1,je_2+1,jk) &
-                             &     + p_fld(ji+2,je_2+1,jk) * zsurfmsk(ji+2,je_2+1,jk) &
-                             &     + p_fld(ji  ,je_2+2,jk) * zsurfmsk(ji  ,je_2+2,jk) &
-                             &     + p_fld(ji+1,je_2+2,jk) * zsurfmsk(ji+1,je_2+2,jk) &
-                             &     + p_fld(ji+2,je_2+2,jk) * zsurfmsk(ji+2,je_2+2,jk) 
-
-                           zsfcrs =  zsurf(ji,je_2  ,jk) + zsurf(ji+1,je_2  ,jk) + zsurf(ji+2,je_2  ,jk) &
-                             &     + zsurf(ji,je_2+1,jk) + zsurf(ji+1,je_2+1,jk) + zsurf(ji+2,je_2+1,jk) &
-                             &     + zsurf(ji,je_2+2,jk) + zsurf(ji+1,je_2+2,jk) + zsurf(ji+2,je_2+2,jk) 
-                            !
-                            p_fld_crs(ii,2,jk) = zflcrs
-                            IF( zsfcrs /= 0.0 )  p_fld_crs(ii,2,jk) = zflcrs / zsfcrs
-                        ENDDO
-                     ENDDO
-                  ENDIF
+                  DO jk = 1, jpk
+                     zsurf   (:,:,jk) =  p_e12(:,:) * p_e3(:,:,jk) *  p_mask(:,:,jk) 
+                     zsurfmsk(:,:,jk) =  zsurf(:,:,jk) 
+                  ENDDO
                   !
-                  DO jk = 1, jpk           
-                     DO jj  = njstr, njend, nn_facty
-                        DO ji = nistr, niend, nn_factx
-                           ii = ( ji - mis_crs(2) ) * rfactx_r + 2                 ! cordinate in parent grid
-                           ij = ( jj - njstr ) * rfacty_r + 3
-                           zflcrs =  p_fld(ji  ,jj  ,jk) * zsurfmsk(ji  ,jj  ,jk) &
-                             &     + p_fld(ji+1,jj  ,jk) * zsurfmsk(ji+1,jj  ,jk) &
-                             &     + p_fld(ji+2,jj  ,jk) * zsurfmsk(ji+2,jj  ,jk) &
-                             &     + p_fld(ji  ,jj+1,jk) * zsurfmsk(ji  ,jj+1,jk) &
-                             &     + p_fld(ji+1,jj+1,jk) * zsurfmsk(ji+1,jj+1,jk) &
-                             &     + p_fld(ji+2,jj+1,jk) * zsurfmsk(ji+2,jj+1,jk) &
-                             &     + p_fld(ji  ,jj+2,jk) * zsurfmsk(ji  ,jj+2,jk) &
-                             &     + p_fld(ji+1,jj+2,jk) * zsurfmsk(ji+1,jj+2,jk) &
-                             &     + p_fld(ji+2,jj+2,jk) * zsurfmsk(ji+2,jj+2,jk) 
-                           zsfcrs =  zsurf(ji,jj  ,jk) + zsurf(ji+1,jj  ,jk) + zsurf(ji+2,jj  ,jk) &
-                             &     + zsurf(ji,jj+1,jk) + zsurf(ji+1,jj+1,jk) + zsurf(ji+2,jj+1,jk) &
-                             &     + zsurf(ji,jj+2,jk) + zsurf(ji+1,jj+2,jk) + zsurf(ji+2,jj+2,jk) 
-                            !
-!cbr                            IF( ieee_is_nan(p_fld_crs(ii,ij,jk))) THEN
-
-                           p_fld_crs(ii,ij,jk) = zflcrs
-                           IF( zsfcrs /= 0.0 )  p_fld_crs(ii,ij,jk) = zflcrs / zsfcrs
+                  DO jk = 1, jpk          
+                     DO jj  = nldj_crs,nlej_crs
+                        ijjs = mjs_crs(jj)
+                        ijje = mje_crs(jj)
+                        DO ji = nldi_crs, nlei_crs
+
+                           ijis = mis_crs(ji)
+                           ijie = mie_crs(ji)
+
+                           zflcrs = SUM( p_fld(ijis:ijie,ijjs:ijje,jk) * zsurfmsk(ijis:ijie,ijjs:ijje,jk) )
+                           zsfcrs = SUM(                                 zsurfmsk(ijis:ijie,ijjs:ijje,jk) )
+
+                           p_fld_crs(ji,jj,jk) = zflcrs
+                           IF( zsfcrs /= 0.0 )  p_fld_crs(ji,jj,jk) = zflcrs / zsfcrs
                         ENDDO      
                      ENDDO
                   ENDDO  
+                  !
                CASE DEFAULT
                     STOP
-               END SELECT
-
-              CALL wrk_dealloc( jpi, jpj, jpk, zsurf, zsurfmsk )
+            END SELECT
+
+            CALL wrk_dealloc( jpi, jpj, jpk, zsurf, zsurfmsk )
+
          CASE ( 'LOGVOL' )
 
             CALL wrk_alloc( jpi, jpj, jpk, zsurf, zsurfmsk, ztabtmp )
-
-            zmin=MINVAL(p_fld) ; zmax=MAXVAL(p_fld);CALL mpp_min(zmin);CALL mpp_max(zmax);IF(lwp)WRITE(numout,*)"p_fld",zmin,zmax; CALL flush(numout)
 
             ztabtmp(:,:,:)=0._wp
             WHERE(p_fld* p_mask .NE. 0._wp ) ztabtmp =  LOG10(p_fld * p_mask)*p_mask
-            zmin=MINVAL(ztabtmp) ; zmax=MAXVAL(ztabtmp);CALL mpp_min(zmin);CALL mpp_max(zmax);IF(lwp)WRITE(numout,*)"LOG()",zmin,zmax; CALL flush(numout)
             ztabtmp = ztabtmp * p_mask
-            zmin=MINVAL(ztabtmp) ; zmax=MAXVAL(ztabtmp);CALL mpp_min(zmin);CALL mpp_max(zmax);IF(lwp)WRITE(numout,*)"LOG()*tmask",zmin,zmax; CALL flush(numout)
 
             SELECT CASE ( cd_type )
 
                CASE( 'T', 'W' )
-                     DO jk = 1, jpk
-                        zsurf   (:,:,jk) =  p_e12(:,:) * p_e3(:,:,jk) *  p_mask(:,:,jk)
-                        zsurfmsk(:,:,jk) =  zsurf(:,:,jk)
-                    ENDDO
-
-                  IF( nldj_crs == 1 .AND. ( ( mje_crs(2) - mjs_crs(2) ) < 2 ) ) THEN     !!cc bande du sud style ORCA2
-                     IF( mje_crs(2) - mjs_crs(2) == 1 ) THEN
-                        je_2 = mje_crs(2)
-                        DO jk = 1, jpk
-                           DO ji = nistr, niend, nn_factx
-                              ii   = ( ji - mis_crs(2) ) * rfactx_r + 2
-                              zflcrs =  ztabtmp(ji  ,je_2,jk) * zsurfmsk(ji  ,je_2,jk)   &
-                                &     + ztabtmp(ji+1,je_2,jk) * zsurfmsk(ji+1,je_2,jk)   &
-                                &     + ztabtmp(ji+2,je_2,jk) * zsurfmsk(ji+2,je_2,jk)
-
-                              zsfcrs =  zsurf(ji,je_2,jk) + zsurf(ji+1,je_2,jk) + zsurf(ji+2,je_2,jk)
-                              !
-                              p_fld_crs(ii,2,jk) = 0._wp
-                              IF( zsfcrs /= 0.0 )  p_fld_crs(ii,2,jk) = zflcrs / zsfcrs
-                              p_fld_crs(ii,2,jk) = 10 ** ( p_fld_crs(ii,2,jk) * p_mask_crs(ii,2,jk) ) * p_mask_crs(ii,2,jk)
-                           ENDDO
-                        ENDDO
-                     ENDIF
-                  ELSE
-                     je_2 = mjs_crs(2)
-                     DO jk = 1, jpk
-                        DO ji = nistr, niend, nn_factx
-                           ii   = ( ji - mis_crs(2) ) * rfactx_r + 2
-                           zflcrs =  ztabtmp(ji  ,je_2  ,jk) * zsurfmsk(ji  ,je_2  ,jk) &
-                             &     + ztabtmp(ji+1,je_2  ,jk) * zsurfmsk(ji+1,je_2  ,jk) &
-                             &     + ztabtmp(ji+2,je_2  ,jk) * zsurfmsk(ji+2,je_2  ,jk) &
-                             &     + ztabtmp(ji  ,je_2+1,jk) * zsurfmsk(ji  ,je_2+1,jk) &
-                             &     + ztabtmp(ji+1,je_2+1,jk) * zsurfmsk(ji+1,je_2+1,jk) &
-                             &     + ztabtmp(ji+2,je_2+1,jk) * zsurfmsk(ji+2,je_2+1,jk) &
-                             &     + ztabtmp(ji  ,je_2+2,jk) * zsurfmsk(ji  ,je_2+2,jk) &
-                             &     + ztabtmp(ji+1,je_2+2,jk) * zsurfmsk(ji+1,je_2+2,jk) &
-                             &     + ztabtmp(ji+2,je_2+2,jk) * zsurfmsk(ji+2,je_2+2,jk)
-
-                           zsfcrs =  zsurf(ji,je_2  ,jk) + zsurf(ji+1,je_2  ,jk) + zsurf(ji+2,je_2  ,jk) &
-                             &     + zsurf(ji,je_2+1,jk) + zsurf(ji+1,je_2+1,jk) + zsurf(ji+2,je_2+1,jk) &
-                             &     + zsurf(ji,je_2+2,jk) + zsurf(ji+1,je_2+2,jk) + zsurf(ji+2,je_2+2,jk)
-                            !
-                            p_fld_crs(ii,2,jk) = 0._wp
-                            IF( zsfcrs /= 0.0 )  p_fld_crs(ii,2,jk) = zflcrs / zsfcrs
-                            p_fld_crs(ii,2,jk) = 10 ** ( p_fld_crs(ii,2,jk) * p_mask_crs(ii,2,jk) ) * p_mask_crs(ii,2,jk)
+
+                  DO jk = 1, jpk
+                     zsurf   (:,:,jk) =  p_e12(:,:) * p_e3(:,:,jk) *  p_mask(:,:,jk)
+                     zsurfmsk(:,:,jk) =  zsurf(:,:,jk)
+                  ENDDO
+                  !
+                  DO jk = 1, jpk
+                     DO jj  = nldj_crs,nlej_crs
+                        ijjs = mjs_crs(jj)
+                        ijje = mje_crs(jj)
+                        DO ji = nldi_crs, nlei_crs
+                           ijis = mis_crs(ji)
+                           ijie = mie_crs(ji)
+                           zflcrs = SUM( p_fld(ijis:ijie,ijjs:ijje,jk) * zsurfmsk(ijis:ijie,ijjs:ijje,jk) )
+                           zsfcrs = SUM(                                 zsurfmsk(ijis:ijie,ijjs:ijje,jk) )
+                           p_fld_crs(ji,jj,jk) = zflcrs
+                           IF( zsfcrs /= 0.0 )  p_fld_crs(ji,jj,jk) = zflcrs / zsfcrs
+                           p_fld_crs(ji,jj,jk) = 10 ** ( p_fld_crs(ji,jj,jk) *  p_mask_crs(ji,jj,jk) ) * p_mask_crs(ji,jj,jk)
                         ENDDO
                      ENDDO
-                  ENDIF
+                  ENDDO
+               CASE DEFAULT
+                    STOP
+            END SELECT
+
+            CALL wrk_dealloc( jpi, jpj, jpk, zsurf, zsurfmsk ,ztabtmp )
+
+         CASE ( 'MED' )
+
+            CALL wrk_alloc( jpi, jpj, jpk, zsurf, zsurfmsk )
+
+            SELECT CASE ( cd_type )
+
+               CASE( 'T', 'W' )
+                  DO jk = 1, jpk
+                     zsurf   (:,:,jk) =  p_e12(:,:) * p_e3(:,:,jk) *  p_mask(:,:,jk)
+                     zsurfmsk(:,:,jk) =  zsurf(:,:,jk)
+                  ENDDO
                   !
                   DO jk = 1, jpk
-                     DO jj  = njstr, njend, nn_facty
-                        DO ji = nistr, niend, nn_factx
-                           ii = ( ji - mis_crs(2) ) * rfactx_r + 2                 ! cordinate in parent grid
-                           ij = ( jj - njstr ) * rfacty_r + 3
-                           zflcrs =  ztabtmp(ji  ,jj  ,jk) * zsurfmsk(ji  ,jj  ,jk) &
-                             &     + ztabtmp(ji+1,jj  ,jk) * zsurfmsk(ji+1,jj  ,jk) &
-                             &     + ztabtmp(ji+2,jj  ,jk) * zsurfmsk(ji+2,jj  ,jk) &
-                             &     + ztabtmp(ji  ,jj+1,jk) * zsurfmsk(ji  ,jj+1,jk) &
-                             &     + ztabtmp(ji+1,jj+1,jk) * zsurfmsk(ji+1,jj+1,jk) &
-                             &     + ztabtmp(ji+2,jj+1,jk) * zsurfmsk(ji+2,jj+1,jk) &
-                             &     + ztabtmp(ji  ,jj+2,jk) * zsurfmsk(ji  ,jj+2,jk) &
-                             &     + ztabtmp(ji+1,jj+2,jk) * zsurfmsk(ji+1,jj+2,jk) &
-                             &     + ztabtmp(ji+2,jj+2,jk) * zsurfmsk(ji+2,jj+2,jk)
-                           zsfcrs =  zsurf(ji,jj  ,jk) + zsurf(ji+1,jj  ,jk) + zsurf(ji+2,jj  ,jk) &
-                             &     + zsurf(ji,jj+1,jk) + zsurf(ji+1,jj+1,jk) + zsurf(ji+2,jj+1,jk) &
-                             &     + zsurf(ji,jj+2,jk) + zsurf(ji+1,jj+2,jk) + zsurf(ji+2,jj+2,jk)
-                            !
-                           p_fld_crs(ii,ij,jk) = 0._wp
-                           IF( zsfcrs /= 0.0 )  p_fld_crs(ii,ij,jk) = zflcrs / zsfcrs
-                           p_fld_crs(ii,ij,jk) = 10 ** ( p_fld_crs(ii,ij,jk) *  p_mask_crs(ii,ij,jk) ) * p_mask_crs(ii,ij,jk)
-                        ENDDO
-                     ENDDO
-                  ENDDO
-               CASE DEFAULT
-                    STOP
-               END SELECT
-
-
-              !WHERE( p_fld .NE. 0._wp ) p_fld=10**(p_fld)
-              !zmin=MINVAL(p_fld) ; zmax=MAXVAL(p_fld);CALL mpp_min(zmin);CALL mpp_max(zmax);IF(lwp)WRITE(numout,*)"10**(p_fld)",zmin,zmax ; CALL flush(numout)
-              !p_fld = p_fld * p_mask
-              !zmin=MINVAL(p_fld) ; zmax=MAXVAL(p_fld);CALL mpp_min(zmin);CALL mpp_max(zmax);IF(lwp)WRITE(numout,*)"10**(p_fld)*tmask",zmin,zmax ; CALL flush(numout)
-
-              zmin=MINVAL(p_fld_crs) ; zmax=MAXVAL(p_fld_crs);CALL mpp_min(zmin);CALL mpp_max(zmax);IF(lwp)WRITE(numout,*)"p_fld_crs",zmin,zmax; CALL flush(numout)
-              !p_fld_crs=10**(p_fld_crs*p_mask_crs)
-              !zmin=MINVAL(p_fld_crs) ; zmax=MAXVAL(p_fld_crs);CALL mpp_min(zmin);CALL mpp_max(zmax);IF(lwp)WRITE(numout,*)"10**(p_fld_crs)",zmin,zmax; CALL flush(numout)
-              !p_fld_crs=p_fld_crs*p_mask_crs
-              !zmin=MINVAL(p_fld_crs) ; zmax=MAXVAL(p_fld_crs);CALL mpp_min(zmin);CALL mpp_max(zmax);IF(lwp)WRITE(numout,*)"10**(p_fld_crs)*tmask",zmin,zmax; CALL flush(numout)
-
-              CALL wrk_dealloc( jpi, jpj, jpk, zsurf, zsurfmsk ,ztabtmp )
-         CASE ( 'MED' )
-
-            CALL wrk_alloc( jpi, jpj, jpk, zsurf, zsurfmsk )
-
-            SELECT CASE ( cd_type )
-
-               CASE( 'T', 'W' )
-                     DO jk = 1, jpk
-                        zsurf   (:,:,jk) =  p_e12(:,:) * p_e3(:,:,jk) *  p_mask(:,:,jk)
-                        zsurfmsk(:,:,jk) =  zsurf(:,:,jk)
-                    ENDDO
-
-                  IF( nldj_crs == 1 .AND. ( ( mje_crs(2) - mjs_crs(2) ) < 2 ) ) THEN     !!cc bande du sud style ORCA2
-                     IF( mje_crs(2) - mjs_crs(2) == 1 ) THEN
-                        je_2 = mje_crs(2)
-                        DO jk = 1, jpk
-                           DO ji = nistr, niend, nn_factx
-                              ii   = ( ji - mis_crs(2) ) * rfactx_r + 2
-
-                              ztmp1(:) = 0._wp
-                              ztmp1(1:3) =  p_fld(ji:ji+2,je_2,jk)
-                              CALL PIKSRT(nn_factx*nn_facty,ztmp1)
-                              ir=0
-                              jr=1
-                              DO WHILE( jr .LE. nn_factx*nn_facty )
-                                 IF( ztmp1(jr) == 0. )THEN
-                                    ir=jr
-                                    jr=jr+1
-                                 ELSE
-                                    EXIT
-                                 ENDIF
-                              ENDDO
-                              IF( ir .LE. nn_factx*nn_facty-1 )THEN
-                                 ALLOCATE( ztmp2(nn_factx*nn_facty-ir) )
-                                 ztmp2(1:nn_factx*nn_facty-ir) = ztmp1(1+ir:nn_factx*nn_facty)
-                                 jr=INT( 0.5 * REAL(nn_factx*nn_facty-ir,wp) )+1
-                                 p_fld_crs(ii,2,jk) = ztmp2(jr)
-                                 DEALLOCATE( ztmp2 )
-                              ELSE
-                                 p_fld_crs(ii,ij,jk) = 0._wp
-                              ENDIF
-
-                           ENDDO
-                        ENDDO
-                     ENDIF
-                  ELSE
-                     je_2 = mjs_crs(2)
-                     DO jk = 1, jpk
-                        DO ji = nistr, niend, nn_factx
-                           ii   = ( ji - mis_crs(2) ) * rfactx_r + 2
-                           
-                           ztmp(:,:)= p_fld(ji:ji+2,je_2:je_2+2,jk)
-                           zdim1(1)=nn_factx*nn_facty
+                     DO jj  = nldj_crs,nlej_crs
+                        ijjs = mjs_crs(jj)
+                        ijje = mje_crs(jj)
+                        DO ji = nldi_crs, nlei_crs
+                           ijis = mis_crs(ji)
+                           ijie = mie_crs(ji)
+
+                           ztmp(:,:)= p_fld(ijis:ijie,ijjs:ijje,jk)
+                           zdim1(1) = nn_factx*nn_facty
                            ztmp1(:) = RESHAPE( ztmp(:,:) , zdim1 )
                            CALL PIKSRT(nn_factx*nn_facty,ztmp1)
+
                            ir=0
                            jr=1
@@ -840,52 +553,18 @@
                               ztmp2(1:nn_factx*nn_facty-ir) = ztmp1(1+ir:nn_factx*nn_facty)
                               jr=INT( 0.5 * REAL(nn_factx*nn_facty-ir,wp) )+1
-                              p_fld_crs(ii,2,jk) = ztmp2(jr)
+                              p_fld_crs(ji,jj,jk) = ztmp2(jr)
                               DEALLOCATE( ztmp2 )
                            ELSE
-                           p_fld_crs(ii,ij,jk) = 0._wp
+                              p_fld_crs(ji,jj,jk) = 0._wp
                            ENDIF
 
                         ENDDO
                      ENDDO
-                  ENDIF
-                  !
-                  DO jk = 1, jpk
-                     DO jj  = njstr, njend, nn_facty
-                        DO ji = nistr, niend, nn_factx
-                           ii = ( ji - mis_crs(2) ) * rfactx_r + 2                 ! cordinate in parent grid
-                           ij = ( jj - njstr ) * rfacty_r + 3
-
-                           ztmp(:,:)= p_fld(ji:ji+2,jj:jj+2,jk) 
-                           zdim1(1)=nn_factx*nn_facty
-                           ztmp1(:) = RESHAPE( ztmp(:,:) , zdim1 )
-                           CALL PIKSRT(nn_factx*nn_facty,ztmp1)
-                           ir=0
-                           jr=1
-                           DO WHILE( jr .LE. nn_factx*nn_facty )
-                              IF( ztmp1(jr) == 0. ) THEN
-                                 ir=jr
-                                 jr=jr+1
-                              ELSE
-                                 EXIT
-                              ENDIF
-                           ENDDO
-                           IF( ir .LE. nn_factx*nn_facty-1 )THEN
-                              ALLOCATE( ztmp2(nn_factx*nn_facty-ir) )
-                              ztmp2(1:nn_factx*nn_facty-ir) = ztmp1(1+ir:nn_factx*nn_facty)
-                              jr=INT( 0.5 * REAL(nn_factx*nn_facty-ir,wp) )+1
-                              p_fld_crs(ii,ij,jk) = ztmp2(jr)
-                              DEALLOCATE( ztmp2 )
-                           ELSE
-                              p_fld_crs(ii,ij,jk) = 0._wp
-                           ENDIF
-
-                        ENDDO
-                     ENDDO
                   ENDDO
                CASE DEFAULT
                     STOP
-               END SELECT
-
-              CALL wrk_dealloc( jpi, jpj, jpk, zsurf, zsurfmsk )
+            END SELECT
+
+           CALL wrk_dealloc( jpi, jpj, jpk, zsurf, zsurfmsk )
  
          CASE ( 'SUM' )
